/******************************************************************************
 *
 * Program: Eventlog plugin for Nagios (nrpe_nt).
 * License: GPL
 *
 * Designed as a Nagios Plugin (based on plugins by Ethan Galstad).
 * Copyright (C) 2004 Stephen Strudwick (Pipex Communications, sas@pipex.net)
 *
 * License Information:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#ifndef eventLogH
#define eventLogH

#include "windows.h"
#include <iostream.h>
#include <assert.h>
#include <time.h>
#include <list>

#define SZAPPNAME				"NRPE_NT"

struct QueueRecord {
  int Capacity;
  int Size;
  char **Array;
};

typedef struct QueueRecord *Record;

struct SourceData
{
	char	sourcName[256];	// sourcename of eventlog record
	DWORD	eventID;		// eventID of eventlog record
	DWORD	EventType;	// event type of eventlog record
  time_t genTime;    // gen time
	int		nMessages;	// number of messages of this event type	
	char*	message;		// description string of the the record
	int		nErr;			  // number of error messages this source has generated
	int		nWarn;			// number of warning messages this source has generated
	int		nInf;			  // number of information messages this source has generated
	int		nAudF;			// number of auditFailure messages this source has generated
	int		nAudS;			// number of auditSuccess messages this source has generated
};

void AddEventSource(char *installDir);

int CheckEventLog(int period, char *exclude, char *exclude_id);

int GetEventlogData(char *ibuf, char *label);

#endif