/******************************************************************************
 *
 * Program: Eventlog plugin for Nagios (nrpe_nt).
 * License: GPL
 *
 * Designed as a Nagios Plugin (based on plugins by Ethan Galstad).
 * Copyright (C) 2004 Stephen Strudwick (Pipex Communications, sas@pipex.net)
 *
 * License Information:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

/*
 * Some lines of code are based or taken from the NetSaintService for NT
 * which is Copyright (c) 2000 Jan Christian Kaldestad which as far as I can tell
 * is freeware.
 */

#include "stdafx.h"
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "common.h"
#include "eventLog.h"

int main(int argc, char* argv[])
{
	char exclude[257];
	char exclude_id[257];
	int mins;
	int rc = OK;
	int i; int config;

	exclude[0] = '\0';
	exclude_id[0] = '\0';

	/* Borrowed from nrpe :) */

	if (argc >1) {
        for(i=1;i <argc;i++) {
            if ( (argv[i][0] == '-') || (argv[i][0] == '/') ) {
                switch(tolower(argv[i][1])) {
                    case 'm':
                        mins = atoi(argv[++i]);
						config=OK;
                        break;
                    case 's':
                        strncpy(exclude,argv[++i],256);
						exclude[256] = '\0';
                        break;
                    case 'i':
                        strncpy(exclude_id,argv[++i],256);
						exclude_id[256] = '\0';
                        break;
					default:
                        break;
				}
			}
		}
	}
      
	if (config == OK)
	    rc = CheckEventLog(mins, exclude, exclude_id);
	else {
		printf ("NRPE_NT Plugin, Eventlog\n");
		printf ("Optionally Specify which service/eventid to IGNORE when they generate\n");
		printf ("errors in the event log and how far back in time to look\n\n");
		printf ("usage: eventlog_nrpe_nt.exe -m minutes <-s \"exluded service,...\"> -i <\"exluded eventid,...\"> Do not include unnecesary white space it will not be removed\n");
		printf ("example: service_nrpe_nt.exe -m 20 -s \"NRPE_NT,...\" -i \"7011,...\"\n");
		printf ("example: service_nrpe_nt.exe -m 7200\n");
		return Unknown;
	}

	if (rc == OK)
	    printf("No new warning or critical messages in eventlog for last %d mins",mins);

	return rc;
}