/******************************************************************************
 *
 * Program: Service Check plugin for Nagios (nrpe_nt).
 * License: GPL
 *
 * Designed as a Nagios Plugin (based on plugins by Ethan Galstad).
 * Copyright (C) 2004 Stephen Strudwick (Pipex Communications, sas@pipex.net)
 *
 * License Information:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

#include "stdafx.h"
#include "common.h"
#include <tchar.h>


char* getTimeDateString()
{
  static char str[1000];

  char date[9];
  char time[9];
  _sntprintf(str, 1000, "DEBUG : %s %s: ", _strdate( date ), _strtime( time ) );
  return str;
}

void printToConsole(const char* theString)
{
    cout << getTimeDateString() << theString <<"\n";
    cout.flush();
}

void debug(const char* format, ...)
{
  // Construct a string
  static TCHAR theString[2048];
  theString[0] = 0;
  va_list arglist;
  va_start(arglist, format);
  _vsntprintf(theString, 2048, format, arglist);

#ifdef DEBUG
  printToConsole(theString);
#endif

}
