/******************************************************************************
 *
 * Program: Service Check plugin for Nagios (nrpe_nt).
 * License: GPL
 *
 * Designed as a Nagios Plugin (based on plugins by Ethan Galstad).
 * Copyright (C) 2004 Stephen Strudwick (Pipex Communications, sas@pipex.net)
 *
 * License Information:
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *****************************************************************************/

/*
 * Some lines of code are based or taken from the NetSaintService for NT
 * which is Copyright (c) 2000 Jan Christian Kaldestad which as far as I can tell
 * is freeware.
 */

#include "stdafx.h"
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "checkService.h"
#include "common.h"

int main(int argc, char* argv[])
{
	char service_name[257];
	int rc;

	/* Get Values from command line */
	if (argc != 2) {
      printf ("NRPE_NT Plugin, Service, GX Networks, Stephen Strudwick\n");
      printf ("usage: service_nrpe_nt.exe \"service name,service name,...\" Do not include unnecesary white space it will not be removed\n");
      printf ("example: service_nrpe_nt.exe \"Event Log,Messenger\"\n");
      return Unknown;
	}

	strncpy(service_name,argv[1],256);
	service_name[256] = '\0';

	rc = CheckServices(service_name);

	return rc;
}

